{% extends "base-backend.html" %}
{% block content %}

<script src="{{ url_for('static', filename='vendor/chartjs/3.6.2/chart.min.js') }}"></script>
<script src="{{ url_for('static', filename='vendor/chartjs/3.6.2/chartjs-adapter-date-fns.bundle.min.js') }}"></script>

<div class="grid ds-header-title">
  <div class="g-col-12">
    <h1>{{ _("My statistics") }}</h1>
  </div>
</div>

<div class="grid mt-3">
  <div class="g-col-12">
    <p class="mb-0">{{ _("Statistics corresponding to the last twelve months of all your forms and answers.") }}</p>
  </div>
</div>

<div class="grid mt-3">
  <div class="g-col-12">
    <div class="card">
      <div class="card-header">
        <h2>
          {{ _("Statistics") }}
          <a href="javascript:void(0)" onclick="javascript:changeYear(-1)"><i data-feather="chevron-left" width="16" height="16" stroke-width="3" aria-label="Previous year"></i></a>
          <span id="stats_year_end">{{stats['year_end']}}</span>
          <a href="javascript:void(0)" onclick="javascript:changeYear(+1)"><i data-feather="chevron-right" width="16" height="16" stroke-width="3" aria-label="Next year"></i></a>
        </h2>
      </div>
      <div class="card-body ds-card-body-with-chart">
        <canvas id="usage-chart" height=100></canvas>
      </div>
    </div>
  </div>
</div>


<script>
const inline_help_file_name = "user_statistics.j2.md";
var data_cache = { 0: {{stats|tojson}} }
var legend_status = [0, 1]
var current_year = 0;

function getDataSets(stats) {
  return [
      {
          label: ["{{ _('Answers')}}"],
          data: stats.answers,
          hidden: !legend_status.includes(0),
          backgroundColor: "rgba(182, 0, 181, 0.7)",
      },
      {
          label: ["{{ _('Total answers')}}"],
          data: stats.total_answers,
          hidden: !legend_status.includes(1),
          backgroundColor: "rgba(0, 190, 0, 0.7)",
      },
      {
          label: ["{{ _('New forms')}}"],
          data: stats.forms,
          hidden: !legend_status.includes(2),
          backgroundColor: "rgba(233, 132, 0, 0.7)",
      },
      {
          label: ["{{ _('Total forms')}}"],
          data: stats.total_forms,
          hidden: !legend_status.includes(3),
          backgroundColor: "rgba(255, 228, 0, 0.7)",
      },
  ]
}

const usage_chart = new Chart(document.getElementById('usage-chart'), {
    type: 'bar',
    data: {
        labels:  {{ stats['labels']|tojson }},
        beginAtZero: true,
        datasets: getDataSets({{ stats|tojson }}),
    },
    options: {
      responsive: true,
      maintainAspectRatio: true,
      scales: {
          y: {
            beginAtZero: true,
            ticks: { precision: 0 }
          }
      },
      plugins: {
        legend: {
          onHover: function (e) {
            e.native.target.style.cursor = 'pointer';
          },
          onLeave: function (e) {
            e.native.target.style.cursor = 'default';
          },
          onClick: function (e, legend_item) {
            if (legend_status.includes(legend_item.datasetIndex)) {
              let pos = legend_status.indexOf(legend_item.datasetIndex);
              legend_status.splice(pos, 1);
            } else {
              legend_status.push(legend_item.datasetIndex)
            }
            Chart.defaults.plugins.legend.onClick.call(null, null, legend_item, e);
          },
          labels: {
            boxWidth: 20,
            usePointStyle: true,
            pointStyle: "rectRounded",
          }
        },
      },
      animation: {
        duration: 500,
      },
    },
});
function updateChart() {
  data = data_cache[current_year]
  $("#stats_year_end").html(data.year_end)
  usage_chart.data.labels = data.labels;
  usage_chart.data.datasets = getDataSets(data);
  usage_chart.update();
}
function changeYear(increment) {
  current_year = current_year + increment
  if (current_year > 0) {
    current_year = 0
    return
  }
  if (data_cache[current_year] !== undefined) {
    updateChart()
    return
  }
  $.ajax({
    url : "{{url_for('user_bp.get_user_usage_graph_data')}}"+"?year-offset="+current_year,
    type: "GET",
    dataType: "json",
    beforeSend: function(xhr, settings) {
      if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
        xhr.setRequestHeader("X-CSRFToken", csrftoken)
      }
    },
    success: function(data, textStatus, jqXHR)
    {
      data_cache[current_year] = data.chart_data
      updateChart()
    }
  });
}
</script>

{% endblock %}
